<!-- DO NOT EDIT: this file is automatically generated using scw-doc-gen -->
# Documentation for `scw marketplace`
Marketplace API.
  
- [Marketplace category management commands](#marketplace-category-management-commands)
  - [Get marketplace resources](#get-marketplace-resources)
  - [List marketplace resources](#list-marketplace-resources)
- [Marketplace images management commands](#marketplace-images-management-commands)
  - [Get a specific marketplace image](#get-a-specific-marketplace-image)
  - [List marketplace images](#list-marketplace-images)
- [Marketplace Local Images management commands](#marketplace-local-images-management-commands)
  - [Get marketplace resources](#get-marketplace-resources)
  - [List local images from a specific image or version](#list-local-images-from-a-specific-image-or-version)
- [Marketplace version management commands](#marketplace-version-management-commands)
  - [Get marketplace resources](#get-marketplace-resources)
  - [List marketplace resources](#list-marketplace-resources)

  
## Marketplace category management commands

Marketplace category management commands.


### Get marketplace resources

Get marketplace resources.

**Usage:**

```
scw marketplace category get [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| category-id | Required |  |



### List marketplace resources

List marketplace resources.

**Usage:**

```
scw marketplace category list
```



## Marketplace images management commands

Marketplace images management commands.


### Get a specific marketplace image

Get a specific marketplace image.

**Usage:**

```
scw marketplace image get [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| label | Required |  |



### List marketplace images

List marketplace images.

**Usage:**

```
scw marketplace image list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| order-by | One of: `name_asc`, `name_desc`, `created_at_asc`, `created_at_desc`, `updated_at_asc`, `updated_at_desc` | Ordering to use |
| arch |  | Choose for which machine architecture to return images |
| category |  | Choose the category of images to get |
| include-eol |  | Choose to include end-of-life images |



## Marketplace Local Images management commands

Marketplace Local Images management commands.


### Get marketplace resources

Get marketplace resources.

**Usage:**

```
scw marketplace local-image get [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| local-image-id | Required |  |



### List local images from a specific image or version

List local images from a specific image or version.

**Usage:**

```
scw marketplace local-image list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| image-id |  |  |
| version-id |  |  |
| order-by | One of: `created_at_asc`, `created_at_desc` |  |
| image-label |  |  |
| zone |  |  |



## Marketplace version management commands

Marketplace version management commands.


### Get marketplace resources

Get marketplace resources.

**Usage:**

```
scw marketplace version get [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| version-id | Required |  |



### List marketplace resources

List marketplace resources.

**Usage:**

```
scw marketplace version list [arg=value ...]
```


**Args:**

| Name |   | Description |
|------|---|-------------|
| image-id |  |  |
| order-by | One of: `created_at_asc`, `created_at_desc` |  |



